var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { InjectVegaTelemetrySlimmer } from 'vega-slimmer/core';
import { ZIndexManagerRuntimeMetricsPayloadDefinition } from '../../constants/runtime-metrics-payload-definition/public-api/zindex-manager/runtime-metrics-payload-definition';
import { createPublicAPIRuntimeMetricsSlimmer } from '../slimmers/runtime-metrics/create-public-api-runtime-metrics-slimmer';
import InternalVegaZIndexManager from './internal-vega-z-index-manager';
/**
 * The VegaZIndexManager class calls a method in the ZIndexManager class to
 * change z-index values based on the input.
 */
class VegaZIndexManager {
  constructor() {
    this.vegaPublicAPIRuntimeMetricsSlimmer = createPublicAPIRuntimeMetricsSlimmer(VegaZIndexManager, ['overrideZIndexBasicValues'], ZIndexManagerRuntimeMetricsPayloadDefinition);
  }
  /**
   * The function "overrideZIndexBasicValues" calls a method in the "ZIndexManager" class to change the
   * z-index values based on the input.
   *
   * @param {ZIndexBasicValues} input - The input parameter is of type ZIndexBasicValues.
   * @vegaVersion 2.3.0
   */
  overrideZIndexBasicValues(input) {
    InternalVegaZIndexManager.overrideZIndexBasicValues(input);
  }
}
__decorate([
  InjectVegaTelemetrySlimmer()
], VegaZIndexManager.prototype, "vegaPublicAPIRuntimeMetricsSlimmer", void 0);
export default new VegaZIndexManager();
